Custom Getpoint

13 篇文章 2 订阅

根据三点画圆弧,绘画中包含了动态显示。
这里写图片描述

# A Rhino GetPoint that performs some custom dynamic drawing
import Rhino
import System.Drawing.Color
import scriptcontext

def CustomArc3Point():
    # Color to use when drawing dynamic lines
    line_color = System.Drawing.Color.FromArgb(255,0,0)
    arc_color = System.Drawing.Color.FromArgb(150,0,50)

    rc, pt_start = Rhino.Input.RhinoGet.GetPoint("Start point of arc", False)
    if( rc!=Rhino.Commands.Result.Success ): return
    rc, pt_end = Rhino.Input.RhinoGet.GetPoint("End point of arc", False)
    if( rc!=Rhino.Commands.Result.Success ): return

    # This is a function that is called whenever the GetPoint's
    # DynamicDraw event occurs
    def GetPointDynamicDrawFunc( sender, args ):
        #draw a line from the first picked point to the current mouse point
        args.Display.DrawLine(pt_start, args.CurrentPoint, line_color, 2)
        #draw a line from the second picked point to the current mouse point
        args.Display.DrawLine(pt_end, args.CurrentPoint, line_color, 2)
        #draw an arc through these three points
        arc = Rhino.Geometry.Arc(pt_start, args.CurrentPoint, pt_end)
        args.Display.DrawArc(arc, arc_color, 1)

    # Create an instance of a GetPoint class and add a delegate
    # for the DynamicDraw event
    gp = Rhino.Input.Custom.GetPoint()
    gp.DynamicDraw += GetPointDynamicDrawFunc
    gp.Get()
    if( gp.CommandResult() == Rhino.Commands.Result.Success ):
        pt = gp.Point()
        arc = Rhino.Geometry.Arc(pt_start,pt,pt_end)
        scriptcontext.doc.Objects.AddArc(arc)
        scriptcontext.doc.Views.Redraw()


if( __name__ == "__main__" ):
    CustomArc3Point()
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值